module dmd.TypeInfoConstDeclaration;

import dmd.Type;
import dmd.TypeInfoDeclaration;
import dmd.Type;
import dmd.backend.dt_t;
import dmd.backend.Util;
import dmd.backend.TYM;

version(DMDV2)
class TypeInfoConstDeclaration : TypeInfoDeclaration
{
	this(Type tinfo)
	{
		super(tinfo, 0);
	    type = Type.typeinfoconst.type;
	}

	override void toDt(dt_t** pdt)
	{
		//printf("TypeInfoConstDeclaration.toDt() %s\n", toChars());
		dtxoff(pdt, Type.typeinfoconst.toVtblSymbol(), 0, TYnptr); // vtbl for TypeInfo_Const
		dtdword(pdt, 0);			    // monitor
		Type tm = tinfo.mutableOf();
		tm = tm.merge();
		tm.getTypeInfo(null);
		dtxoff(pdt, tm.vtinfo.toSymbol(), 0, TYnptr);
	}
}

