module dmd.CompoundDeclarationStatement;

import dmd.CompoundStatement;
import dmd.Loc;
import dmd.ArrayTypes;
import dmd.Statement;
import dmd.OutBuffer;
import dmd.HdrGenState;

class CompoundDeclarationStatement : CompoundStatement
{
    this(Loc loc, Statements s)
	{
		super(loc, s);
		///statements = s;
	}
	
    override Statement syntaxCopy()
	{
		Statements a = new Statements();
		a.setDim(statements.dim);
		for (size_t i = 0; i < statements.dim; i++)
		{	
			Statement s = cast(Statement)statements.data[i];
			if (s)
				s = s.syntaxCopy();
			a.data[i] = cast(void*)s;
		}
		CompoundDeclarationStatement cs = new CompoundDeclarationStatement(loc, a);
		return cs;
	}
	
    override void toCBuffer(OutBuffer buf, HdrGenState* hgs)
	{
		assert(false);
	}
}
